<?php
/*******************************************************************************
 *
 * This file is part of the Meet plugin for Kopano WebApp
 *
 * (c) 2019 Kopano <info@kopano.com>
 *
 *******************************************************************************/

if (!defined('PLUGIN_MEET_MEET_JOIN_URL')) {
	define('PLUGIN_MEET_MEET_JOIN_URL', '/meet/r/join/group/');
}

if (!defined('PLUGIN_MEET_MEET_URL')) {
	define('PLUGIN_MEET_MEET_URL', '/meet/');
}

if (!defined('PLUGIN_MEET_USER_DEFAULT_ENABLE')) {
	define('PLUGIN_MEET_USER_DEFAULT_ENABLE', false);
}

class Pluginmeet extends Plugin {
	/**
	 * Function initializes the Plugin and registers all hooks
	 */
	function init() {
		$this->registerHook('server.core.settings.init.before');
	}

	/**
	 * Function is executed when a hook is triggered by the PluginManager
	 *
	 * @param string $eventID the id of the triggered hook
	 * @param mixed $data object(s) related to the hook
	 */
	function execute($eventID, &$data) {
		switch($eventID) {
			case 'server.core.settings.init.before' :
				$this->injectPluginSettings($data);
				break;
		}
	}


	/**
	 * Called when the core Settings class is initialized and ready to accept sysadmin default
	 * settings. Registers the sysadmin defaults for the meet plugin.
	 * @param Array $data Reference to the data of the triggered hook
	 */
	function injectPluginSettings(&$data) {
		$pluginData = array(
			'default_enable' => PLUGIN_MEET_USER_DEFAULT_ENABLE,
			'meet_url' => PLUGIN_MEET_MEET_URL,
			'meet_join_url' => PLUGIN_MEET_MEET_JOIN_URL,
		);

		$data['settingsObj']->addSysAdminDefaults(Array(
			'zarafa' => Array(
				'v1' => Array(
					'plugins' => Array(
						'meet' => $pluginData
					)
				)
			)
		));
	}
}
